import { world, system } from "@minecraft/server";

// This code was created by Zakleby#0001 and is used inside of the Scripting Hub. Feel free to change anything

var time_until_punishment = 120 // number of seconds until the user will be kicked
var kick_message = `§cYou were afk for over ${(time_until_punishment / 60).toFixed(2)} minutes` // the message the user will see on the kick screen
var chat_message = `§c{!} <username> was kicked for AFK.` // the message that will get sent to chat. Use <username> to get the players username

const antiAfk = new Map();

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const { x, z } = player.getVelocity();

        if (x == 0 && z == 0) antiAfk.set(player.id, antiAfk.get(player.id) ? antiAfk.get(player.id) + 1 : 1);
        else antiAfk.delete(player.id);

        if (antiAfk.get(player.id) > time_until_punishment) {
            antiAfk.delete(player.id);

            // code below this point is for punishing the player
            player.runCommandAsync(`kick "${player.name}" ${kick_message}`);

            const msg = chat_message.replace("<username>", `${player.name}`);
            world.sendMessage(msg);
        }
    }
}, 20);